using System;
using UnityEngine;
using UnityEngine.Experimental.Rendering;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using SimpleJSON;
using System.Linq;
using MVR;
using MeshVR;
using MVR.FileManagementSecure;
using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;
using GPUTools.Cloth.Scripts;
using Unity.Collections;
using AssetBundles;
using System.Diagnostics;
using static System.Diagnostics.Stopwatch;
using Battlehub.RTCommon;

/*


*/
namespace Stopper {
	public class BodyMeshColliders : MVRScript {
		

		Mesh skinMesh;

		
		DAZMergedSkinV2 mergedSkin;
		Vector3[] skinVertices;

		int frameCount = 0;

		ComputeBuffer skinBuffer;

		// Penis Colliders
		DAZBone gen3;
		private List<MeshColliderSpec> penisMeshColliders = new List<MeshColliderSpec>();
		
		static int trianglecount = 218*3;
		int[] penisTriangles;
		int[] penisSubmeshTriangles;
		Vector3[] penisVertices;

		Vector3 penisScale = new Vector3(1f,1f,1f);
		
		// UI
		JSONStorableBool showPreview;
		
		JSONStorableBool disableOriginalColliders;
		JSONStorableFloat framesBetweenUpdate;
		
		Material lineMaterial;
		
		public class MeshColliderSpec {
			public int[] submeshTriangles;
			
			public int startIndex;
			public int endIndex; 
			
			public Vector3[] meshVertices;
			public int[] meshTriangles;

			public DAZBone bone;

			public MeshCollider meshCollider;

			public GameObject container;
			public SkinnedMeshRenderer renderer;
		}

		public override void Init() {
			

			mergedSkin = containingAtom.GetComponentInChildren<DAZMergedSkinV2>();
			skinBuffer = mergedSkin.smoothedVertsBuffer;
			skinVertices = new Vector3[skinBuffer.count];
			
			gen3 = containingAtom.GetStorableByID("Gen3") as DAZBone;

			// Set up preview renderer
			lineMaterial = new Material(Shader.Find("Battlehub/RTGizmos/Handles"));
			lineMaterial.SetFloat("_Offset",1f);
			lineMaterial.SetFloat("_MinAlpha", 1f);
			lineMaterial.renderQueue = 3000;

			Color previewColor = Color.green;
			previewColor.a = 0.5f;
			lineMaterial.color = previewColor;

			// Create penis collider
			penisVertices = new Vector3[trianglecount];
			penisTriangles = new int[trianglecount];

			// Hack to make this compatible with AltFuta. The submesh order is different for AltFuta
			for(int i = mergedSkin.Mesh.subMeshCount-1; i >= 0; i--) {
				var subMeshTriangles = mergedSkin.Mesh.GetTriangles(i);
				if(subMeshTriangles.Length == 6972){
					penisSubmeshTriangles = subMeshTriangles;
					break;
				}
			}
			if(penisSubmeshTriangles == null) {
				throw new Exception("Unable to find penis submesh. Is this a Male/AltFuta Atom?");
			}

			
			skinBuffer.GetData(skinVertices,0,0,skinBuffer.count);
			
			penisMeshColliders.Add(AddPenisCollider(gen3, 0, 218, penisSubmeshTriangles));

			penisMeshColliders.Add(AddPenisCollider(gen3, 218, 440, penisSubmeshTriangles));

			// UI
			showPreview = new JSONStorableBool("Show Preview", false);
			RegisterBool(showPreview);
			var showPreviewToggle = CreateToggle(showPreview, false);
			showPreviewToggle.toggle.onValueChanged.AddListener((val) => {
				foreach(var spec in penisMeshColliders) {
					spec.renderer.enabled = val;
				}
			});

			disableOriginalColliders = new JSONStorableBool("Disable Original Colliders", true);
			RegisterBool(disableOriginalColliders);
			var disableOriginalCollidersToggle = CreateToggle(disableOriginalColliders, false);
			disableOriginalCollidersToggle.toggle.onValueChanged.AddListener((val) => {
				SyncOriginalColliders(val);
			});

			var frameBetweenUpdateSlider = AddSlider("Frames Between Shape Update",30,0,120,null,true);
			framesBetweenUpdate = sliderToJSONStorableFloat[frameBetweenUpdateSlider];

			AddSlider("Penis Collider Scale X",1f,0f,2f, (scale) => {
				penisScale.x = scale;
				UpdatePenisColliderScale();
			});
			AddSlider("Penis Collider Scale Y",1f,0f,2f, (scale) => {
				penisScale.y = scale;
				UpdatePenisColliderScale();
			});
			AddSlider("Penis Collider Scale Z",1f,0f,2f, (scale) => {
				penisScale.z = scale;
				UpdatePenisColliderScale();
			});

			OnEnable();
		}
		
		private void Start() {
		}
		
		private void Update() {
			if(framesBetweenUpdate.val == 0 || frameCount % (int)framesBetweenUpdate.val == 0) {
				skinBuffer.GetData(skinVertices,0,0,skinBuffer.count);

				foreach(var spec in penisMeshColliders){
					UpdatePenisCollider(spec);
				}
			}
			frameCount++;
			return;
		}

		private MeshColliderSpec AddPenisCollider(DAZBone bone, int startTriangleIndex, int endTriangleIndex, int[] submeshTriangles){
			GameObject container = new GameObject("MeshColliderContainer");
			container.transform.SetParent(bone.transform);
			container.layer = 0;
			
			var penisMeshCollider = container.AddComponent<MeshCollider>();
			penisMeshCollider.sharedMesh = new Mesh();
			penisMeshCollider.convex = true;

			
			MeshColliderSpec spec = new MeshColliderSpec();
			spec.bone = bone;
			spec.meshCollider = penisMeshCollider;
			spec.startIndex = startTriangleIndex;
			spec.endIndex = endTriangleIndex;
			spec.submeshTriangles = submeshTriangles;
			spec.container = container;

			int trianglecount = endTriangleIndex - startTriangleIndex;
			spec.meshVertices = new Vector3[trianglecount*3];
			spec.meshTriangles = new int[trianglecount*3];

			var penisMeshColliderRenderer = container.AddComponent<SkinnedMeshRenderer>();
			penisMeshColliderRenderer.material = lineMaterial;
			penisMeshColliderRenderer.enabled = false;

			spec.renderer = penisMeshColliderRenderer;
			
			UpdatePenisCollider(spec);

			foreach(Collider collider in bone.gameObject.GetComponentsInChildren<Collider>(true)){
				Physics.IgnoreCollision(penisMeshCollider, collider, true);
			}

			container.SetActive(true);
			return spec;
		}

		private void UpdatePenisColliderScale() {
			foreach(var spec in penisMeshColliders) {
				spec.container.transform.localScale = Vector3.Scale(spec.bone.transform.localScale, penisScale);
			}
		}
			
		private void UpdatePenisCollider(MeshColliderSpec spec) {
			for(int i = 0; i < (spec.endIndex-spec.startIndex)*3; i++) {
				spec.meshVertices[i] = spec.bone.transform.InverseTransformPoint(skinVertices[spec.submeshTriangles[spec.startIndex*3+i]]);
				spec.meshTriangles[i] = i;
			}

			Mesh mesh = spec.meshCollider.sharedMesh;
			mesh.vertices = spec.meshVertices;
			mesh.triangles = spec.meshTriangles;
		
			mesh.RecalculateBounds();
			
			spec.meshCollider.sharedMesh = null;
			spec.meshCollider.sharedMesh = mesh;

			spec.container.transform.position = spec.bone.transform.position;
			spec.container.transform.rotation = spec.bone.transform.rotation;
			spec.container.transform.localScale = Vector3.Scale(spec.bone.transform.localScale, penisScale);

			spec.renderer.sharedMesh = spec.meshCollider.sharedMesh;
		}

		private void SyncOriginalColliders(bool disable) {
			foreach(var collider in gen3.GetComponentsInChildren<Collider>(true)) {
				collider.enabled = !disable;
			}

			foreach(var spec in penisMeshColliders) {
				spec.meshCollider.enabled = true;
			}
		}
		
		private void OnDisable()
		{
			SyncOriginalColliders(false);
			
			foreach(var spec in penisMeshColliders) {
				spec.container.SetActive(false);
			}
		}

		private void OnEnable()
		{
			foreach(var spec in penisMeshColliders) {
				spec.container.SetActive(true);
			}
			SyncOriginalColliders(disableOriginalColliders.val);
		}

		private void OnDestroy()
		{
			foreach(var spec in penisMeshColliders) {
				UnityEngine.Object.Destroy(spec.container);
			}
		}

		public UIDynamicSlider AddSlider(string name, float defaultVal, float min, float max, JSONStorableFloat.SetFloatCallback onChange = null, bool wholeNumbers = false, bool rightSide = false){
            JSONStorableFloat storableFloat = new JSONStorableFloat(name, defaultVal, min, max, true, true);
            storableFloat.storeType = JSONStorableParam.StoreType.Full;
            UIDynamicSlider uiSlider = this.CreateSlider(storableFloat, rightSide);
            uiSlider.rangeAdjustEnabled = true;
            uiSlider.slider.wholeNumbers = wholeNumbers;
            RegisterFloat(storableFloat);
            
            if(onChange != null){
                storableFloat.setCallbackFunction = onChange;
            }
            
            return uiSlider;
	    }
	}
}